org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class PathStep<S>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.map.MapStep<S,E>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.ScalarMapStep<S,Path>
      - - org.apache.tinkerpop.gremlin.process.traversal.step.map.PathStep<S>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<Path>>, Step<S,Path>, ByModulating, FromToModulating, PathProcessor, TraversalParent

      public final class PathStep<S>
      extends ScalarMapStep<S,Path>
      implements TraversalParent, PathProcessor, ByModulating, FromToModulating

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `PathProcessor.ElementRequirement`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PathStep(Traversal.Admin traversal)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addFrom(String fromLabel)`
    `void` | `addTo(String toLabel)`
    `PathStep<S>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `String` | `getFromLabel()`
    `Set<String>` | `getKeepLabels()`
    `List<Traversal.Admin<Object,Object>>` | `getLocalChildren()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `String` | `getToLabel()`
    `int` | `hashCode()`
    `protected Path` | `map(Traverser.Admin<S> traverser)`
    `void` | `modulateBy(Traversal.Admin<?,?> pathTraversal)`
    `protected Traverser.Admin<Path>` | `processNextStart()`
    `void` | `replaceLocalChild(Traversal.Admin<?,?> oldTraversal, Traversal.Admin<?,?> newTraversal)`
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `void` | `setKeepLabels(Set<String> keepLabels)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `getMaxRequirement, processTraverserPathLabels`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.FromToModulating

      `addFrom, addTo`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### PathStep

          public PathStep(Traversal.Admin traversal)

  - ### Method Detail

    - #### map

          protected Path map(Traverser.Admin<S> traverser)

      Specified by:
        `map` in class `ScalarMapStep<S,Path>`

    - #### clone

          public PathStep<S> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,Path>`
      Overrides:
        `clone` in class `AbstractStep<S,Path>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,Path>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,Path>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,Path>`

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<S,Path>`
      Overrides:
        `reset` in class `AbstractStep<S,Path>`

    - #### getLocalChildren

          public List<Traversal.Admin<Object,Object>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> pathTraversal)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### replaceLocalChild

          public void replaceLocalChild(Traversal.Admin<?,?> oldTraversal,
                                        Traversal.Admin<?,?> newTraversal)

      Specified by:
        `replaceLocalChild` in interface `TraversalParent`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,Path>`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,Path>`
      Returns:
        the set of requirements

    - #### setKeepLabels

          public void setKeepLabels(Set<String> keepLabels)

      Specified by:
        `setKeepLabels` in interface `PathProcessor`

    - #### processNextStart

          protected Traverser.Admin<Path> processNextStart()

      Overrides:
        `processNextStart` in class `ScalarMapStep<S,Path>`

    - #### getKeepLabels

          public Set<String> getKeepLabels()

      Specified by:
        `getKeepLabels` in interface `PathProcessor`

    - #### addFrom

          public void addFrom(String fromLabel)

      Specified by:
        `addFrom` in interface `FromToModulating`

    - #### addTo

          public void addTo(String toLabel)

      Specified by:
        `addTo` in interface `FromToModulating`

    - #### getFromLabel

          public String getFromLabel()

    - #### getToLabel

          public String getToLabel()

Copyright © 2013–2021 Apache Software Foundation. All rights reserved.